/* ----------------------------------------------------------
%   (C)1993,1994,1995 Institute for New Generation Computer Technology
%       (Read COPYRIGHT for detailed information.)
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_GC_MACRO_H_
#define _KLIC_GC_MACRO_H_

#include <klic/stdc.h>  /* CONCATENATE */
#include <klic/basic.h>  /* fatal, debug_printf, klic_fprintf, klic_putc */
#include <klic/g_basic.h>

/* runtime/unify.c */
extern void do_shallow_unify(q x, q y);
extern void do_shallow_unify_value(q x, q y);
extern void set_rest_of_stream(q term);

/* runtime/generic.c */
extern void G_SUSPEND(q x, struct goalrec* goal);
extern q GC_MAKE_HOOK_VAR(struct consumer_object* obj);

#define    GC_RETURN_WITH_HOOK(x) \
do{ \
  set_rest_of_stream(x); \
  return; \
}while(0)

#define GC_TERMINATE \
do{ \
  set_rest_of_stream(NULL); \
  return; \
}while(0)

/***************************************************************************/

#define GC_TRY_TO_ALLOC(new, type, size, gc_request) \
do{ \
  q res; \
  G_HEAPALLOC_WITH_CHECK((new), (size), type, res); \
  if (res == GENERIC_GCREQUEST) goto gc_request; \
}while(0)

/**************************************************************************/

#define GCSET_NEWOBJ_FOR_NEW(newgobj,size) \
do{ \
  q res; \
  G_HEAPALLOC_WITH_CHECK((newgobj), (size), (GC_OBJ_TYPE*), res); \
  if(res == GENERIC_GCREQUEST){ \
    q var; \
    struct goalrec *goal; \
    G_MAKE_THE_NEW_GOAL(&var, &goal, g_myself, g_argc, g_argv); \
    G_PUSH_GOAL_TO_SPECIAL_QUEUE(goal); \
    return var; \
  } \
  (newgobj)->method_table = &G_method_table; \
}while(0)


/**********************************************************************/

#define GCDEF_UNIFY() \
static void G_rappend(active_unify) (GC_OBJ_TYPE* GC_SELF, q g_term)

#define GC_PRINT(x) klic_fprintf(g_fp, (x))

#define GCDEF_PRINT() \
  static \
  long \
  G_rappend(print) (GC_SELF,g_fp,g_depth,g_length) \
    GC_OBJ_TYPE *GC_SELF; \
    FILE *g_fp; \
    unsigned long g_depth; \
    unsigned long g_length;

/******************************************************************/

#define GCDEF_GC() \
static q* G_rappend(gc) (GC_OBJ_TYPE* GC_SELF)

#define GCSET_NEWOBJ_IN_NEWGEN(newobj) \
do{ \
  unsigned long size = GC_OBJ_SIZE(GC_SELF); \
  *heapp() = (q) GC_SELF->method_table; \
  (newobj) = (GC_OBJ_TYPE*) klic_alloc(size); \
  if(heapp() > real_heaplimit()) fatal("not enough space collected"); \
}while(0)

#define GCDEF_DEALLOCATE() \
  static void \
  G_rappend(deallocate) (GC_SELF) \
    GC_OBJ_TYPE* GC_SELF;

/*******************************************/

#define GCSET_MESSAGE(message)					\
do{								\
  (message) = G_CAR_OF(g_term);				\
  while (G_ISREF(message)) {					\
    q temp = G_DEREFONE(message);				\
    if (G_ISREF(temp) &&					\
	(temp == (message) || G_DEREFONE(temp) == (message))) {	\
      reason = (message);					\
      GC_SELF->stream = g_term;				\
      goto suspend;						\
    } else {							\
      (message) = temp;						\
    }								\
  }								\
}while(0)

#define GCSET_MESSAGE_INT_ARG(arg, message, pos)		\
do{								\
  q temp = G_ARG((message), (pos));				\
  while (!G_ISINT(temp)) {					\
    if (G_ISREF(temp)) {					\
      q temp1 = G_DEREFONE(temp);				\
      if (G_ISREF(temp1) && G_DEREFONE(temp1) == temp) {	\
	reason = temp1;						\
	GC_SELF->stream = g_term;				\
	goto suspend;						\
      }								\
      temp = temp1;						\
    } else {							\
      goto message_error;					\
    }								\
  }								\
  (arg) = G_INTVAL(temp);					\
}while(0)

#define GCSET_MESSAGE_STR_ARG(arg, message, pos)		\
do{								\
  q temp = G_ARG((message), (pos));				\
  while (!G_ISGOBJ(temp) ||					\
	 (struct data_object_method_table *)			\
	 G_FUNCTOR_OF(temp) !=					\
	 &byte__string_g_method_table) {			\
    if (G_ISREF(temp)) {					\
      q temp1 = G_DEREFONE(temp);				\
      if (G_ISREF(temp1) && G_DEREFONE(temp1) == temp) {	\
	reason = temp1;						\
	GC_SELF->stream = g_term;				\
	goto suspend;						\
      }								\
      temp = temp1;						\
    } else {							\
      goto message_error;					\
    }								\
  }								\
  (arg) = (struct byte_string_object *) G_FUNCTORP(temp);	\
}while(0)

#define GCSET_VAR(self)  ((self) = G_MAKEREF(&(self)))

extern struct predicate predicate_unify__term__dcode_xunify__goal_2;
#define GC_KL1_UNIFY(x, y) \
do{ \
  struct goalrec *gp; \
  G_HEAPALLOC(gp, 4, (struct goalrec *)); \
  gp->pred = &predicate_unify__term__dcode_xunify__goal_2; \
  gp->args[0] = (x); \
  gp->args[1] = (y); \
  resume_same_prio(gp); \
}while(0)

#endif /* _KLIC_GC_MACRO_H_ */
