/* ---------------------------------------------------------- 
%   (C)1993,1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_GG_MACRO_H_
#define _KLIC_GG_MACRO_H_

#include <klic/stdc.h>  /* CONCATENATE */
#include <klic/basic.h>  /* fatal, klic_fprintf */

extern q GC_wakeup_g_new();

/* runtime/unify.c */
extern void do_shallow_unify(q x, q y);

/* runtime/generic.c */
extern void G_SUSPEND(q x, struct goalrec* goal);
extern q GG_MAKE_HOOK_VAR(struct generator_object* obj);

#define GG_OBJ_SIZE G_SIZE_IN_Q(GG_OBJ_TYPE)

#define GG_TERMINATE  do{ return !0; }while(0)

#define GG_SUSPEND(var) \
do{ \
  q newvar, tmp; \
  q argv[2]; \
  G_MAKE_VAR(newvar); \
  argv[0] = g_term; \
  argv[1] = newvar; \
  tmp = GC_wakeup_g_new(2, argv); \
  GG_KL1_UNIFY((var), tmp); \
  return heapp(); \
}while(0)

/***************************************************************************/

#define GG_DEREF(x) \
do{ \
  while (1) { \
    if (!isstruct(x)) { \
      if (atomicnotref(x)) { \
	break; \
      } else { \
	q temp0 = derefone(x); \
	if(isref(temp0) && (x) == derefone(temp0)) { \
	  GG_SUSPEND(x); \
	} else { \
	  (x) = temp0; \
	} \
      } \
    } else { \
      break; \
    } \
  } \
}while(0)

/**************************************************************************/

#define GGSET_NEWOBJ_FOR_NEW(newgobj, type) \
do{ \
  q res; \
  G_HEAPALLOC_WITH_CHECK((newgobj), GG_OBJ_SIZE, type, res); \
  if(res == GENERIC_GCREQUEST) { \
    q var; \
    struct goalrec *goal; \
    G_MAKE_THE_NEW_GOAL(&var, &goal, g_myself, g_argc, g_argv); \
    G_PUSH_GOAL_TO_SPECIAL_QUEUE(goal); \
    return var; \
  } \
  (newgobj)->method_table = &G_method_table; \
}while(0)

/**********************************************************************/

#define GGDEF_UNIFY() \
static int G_rappend(active_unify) (q GG_SELF, q g_term)

#define GGDEF_SUSPEND() \
static q \
G_rappend(suspend) (GG_SELF, GG_GOAL) \
  q GG_SELF; \
  struct goalrec* GG_GOAL;

#define GGDEF_GENERATE() \
static q G_rappend(generate) (GG_OBJ_TYPE* GG_SELF)

#define GGDEF_PRINT() \
  static \
  long \
  G_rappend(print) (GG_SELF,g_fp,g_depth,g_length) \
    GG_OBJ_TYPE *GG_SELF; \
    FILE *g_fp; \
    unsigned long g_depth; \
    unsigned long g_length;

/******************************************************************/


#define GGDEF_GC() \
static q* G_rappend(gc) (GG_OBJ_TYPE* GG_SELF)

#define GGSET_NEWOBJ_IN_NEWGEN(newobj) \
do{ \
  unsigned long size = GG_OBJ_SIZE; \
  *heapp() = (q) GG_SELF->method_table; \
  (newobj) = (GG_OBJ_TYPE *) klic_alloc(size); \
  if(heapp() > real_heaplimit()) fatal("not enough space collected"); \
}while(0)

#define GGDEF_DEALLOCATE() \
  static void \
  G_rappend(deallocate) (GG_SELF) \
    GG_OBJ_TYPE* GG_SELF;

/*******************************************/

#define GGSET_INTARG_FOR_NEW(var,argv_i) \
do{ \
  G_DEREF_FOR_NEW(argv_i); \
  if(!G_ISINT(argv_i)) fatal("not integer"); \
  (var) = G_INTVAL(argv_i); \
}while(0)

extern struct predicate predicate_unify__term__dcode_xunify__goal_2;
#define GG_KL1_UNIFY(x, y) \
do{ \
  struct goalrec *gp; \
  G_HEAPALLOC(gp, 4, (struct goalrec *)); \
  gp->pred = &predicate_unify__term__dcode_xunify__goal_2; \
  gp->args[0] = (x); \
  gp->args[1] = (y); \
  resume_same_prio(gp); \
}while(0)

/*** for Distribute KLIC system ***/

#define GGDEF_ENCODE() \
  static q \
  G_rappend(encode) (GG_SELF, buffer, depth)\
    GG_OBJ_TYPE *GG_SELF;\
    combuf *buffer;\
    long depth;

#endif /* _KLIC_GG_MACRO_H_ */
